/* entfernen berflssiger cr und lf aus textdateien - weitere konvertierungen */
/* Version 002 */
/* ilja kaufmann, mrz 1997  */
/* email: kaufmann@cip.physik.uni-wuerzburg.de */

zeichen='.:")!?'                              /* zeichen nach denen lf oder der cr bleibt */
zeichen=insert(D2C(13), zeichen)     /* return ist dabei auch wichtig */
zeichen=insert(D2C(10), zeichen)     /* ebenso wie der linefeed */

/* Befehlsliste */

be.1="CR"
be.2="LF"
be.3="TAB"
be.4="SP"
be.5="SK"

beanz=5

umbruch=insert(D2C(13), D2C(10))    /* falls man mal nach return+linefeed sucht und fr 'kill' als 'zeichen' */

zahlen="1234567890"


arg parameter       /* bergebene Parameter aufnehmen */


/* Dateiname extrahieren - ist jeweils das letzte wort in 'parameter' */

parameter=Reverse(Parameter)           /* zeichenkette rckwrts */

if pos('"', parameter)=0 then do                /* falls dateiname nicht in anfhrungszeichen ...*/
    parse var parameter datei parameter    /* ...erstes wort rausholen */
end /* do */
else do                                                 /* wenn dateiname in anfhrungszeichen... */
  p=lastpos('"', parameter)                      /* ...die ersten " suchen */
  p=pos(" ", parameter, p)                       /* ...nchstes leerzeichen unterhalb der " */
  if p=0 then p=length(parameter)+1         /* ...gab es keines -> ganzen parameterstring als dateinamen */
  datei=substr(parameter, 1, p-1)              /* ...dateiname aus parameter extrahieren */
  do while pos('"', datei)>0                        /* ... alle " aus dateinamen lschen */
     datei=delstr(datei, pos('"', datei),1 )
  end /* do */
  parameter=delstr(parameter, 1, p)     /* dateiname aus parameter lschen */
end /* do */

parameter=reverse(parameter)                    /* wieder zurckdrehen */
datei=reverse(datei)                               

if parameter="" then call hilfe       /* keine parameter -> hilfe ausgeben */

/* ebenso wenn zu kill nichts weiter angegeben wurde */
if (pos("KILL", parameter)>0 & pos("LF", parameter)=0 & pos("CR", parameter)=0) then parameter=insert("CR LF ", parameter)
if pos("KILL", parameter)>0 then zeichen=umbruch   /* rcksichtslos auf satzende o.. wird linefeed oder/und return entfernt */


/* Testweise ausgabe des erkannten dateinamen und der restparameter */

say
say "Datei: " datei
say "Parameter: " parameter


/* Parameter in Befehlsliste umsetzen */

befehlanzahl=0
do forever
  ma=length(parameter)+1       /* lnge des parameterausdrucks */
  a=0                                     /* kein befehl */
  do i=1 to beanz by 1               /* alle oben angegebenen befehle durchgehen */
     p=pos(be.i, parameter)        /* befehl in parameter suchen */
    if (p<ma & p>0) then do       /* wenn gefunden und weiter vorne als schon gefundener steht... */
       ma=p                              /* ...position in "parameter" merken */
       a=i                                  /*  ...befehlsnummer merken */
     end /* do */
  end /* do */
  if a=0 then leave                     /* wenn kein befehl mehr gefunden -> raus, sonst... */
 
  nzahl=""
  npos=pos(be.a, parameter)+length(be.a)       /* postion hinter dem befehl in den parametern */
  do while npos<=length(parameter)               /* wiederhole bis maximal zum ende von parameter */
    if pos(substr(parameter, npos, 1), zahlen)>0 then nzahl=insert(nzahl, substr(parameter, npos, 1))
    else leave        /* steht dort eine ziffer, wird sie an tabzahl angehngt - sonst schleife verlassen */
    npos=npos+1    /* nchste position */
  end /* do */
  if \(nzahl>0) then nzahl=0      /* wenn keine anzahl angegeben -> auf 0 setzen */
  parameter=delstr(parameter, pos(be.a, parameter), length(be.a) )    /* befehl aus "parameter" lschen */
  befehlanzahl=befehlanzahl+1     /* befehlanzahl in liste um eines erhhen */
  befehl.befehlanzahl=a               /* gefundenen befehl in der liste 'befehl' als neuen merken */
  zahl.befehlanzahl=nzahl            /* ermittelten wert zum befehl in der liste 'zahl' merken */
end /* do */

say
say befehlanzahl "auszufhrende Befehle:"

do i=1 to befehlanzahl by 1
  if befehl.i=3 & zahl.i=0 then zahl.i=3    /* defaultwert bei tab ohne wertangabe */
  if befehl.i=4 & zahl.i=0 then zahl.i=2    /* defaultwert bei sp ohne wertangabe */
  if befehl.i=5 & zahl.i=0 then zahl.i=1    /* defaultwert bei sk ohne wertangabe derzeit wirkungslos*/
  a=befehl.i
  say a be.a zahl.i
end /* do */

/* say chars(datei) */
if chars(datei)<1 then do     /* wenn leere datei... */
  say
  say "Die Datei" datei 
  say "ist leer oder existiert nicht."
  say "Bitte korrekten Namen angeben"
  say "oder drag-and-drop benutzen!"
  say
  say "Return - Abbruch"
  pull ok
  exit 
end /* do */


text=charin(datei, 1, chars(datei))          /* ganze datei in 'text' laden */

if pos(D2C(0), text)>0 then  do  /* testen auf nullcharacter */
  say
  say "Das ist mit Sicherheit kein einfaches Textfile,"
  say "es enthlt mindestens einen NULL-character."
  say "Trotzdem durcharbeiten? Y,J/N"
  pull antwort
  if translate(antwort)="N" then exit
end


/* neuen Ausgabedateinamen kreieren mit ...?.* drin */

nummer=1
do forever                                               /* ewig wiederholen */
  datei1=reverse(datei)                                /* dateiname rckwrts */
  position=pos(".", datei1)                             /* ersten "." rckwrts in datei suchen */
  if position>4 then position=0                        /* wenn zu weit vorne (hinten) -> =0  */
  nummers=insert(reverse(nummer), "u_")        /* einschubnummer erstellen */
  datein=insert(nummers, datei1, position)       /* einschieben */
  datein=reverse(datein)                               /* dateiname wieder vorwrts */
  ok=charin(datein,,1)                                  /* neue datei 'ansprechen' */
  if chars(datein)<1 then leave                      /* wenn datei leer, dann weiter */
  nummer=nummer+1                                   /* sonst mit neuer nummer nochmal versuchen */
end /* do */

say
say "neue Datei: " datein                  /* neuen namen bekanntgeben */

say
if length(text)*befehlanzahl>20000 then say "Einen Moment Geduld, ist ein greres File"

/* hauptprogramm: aufruf der verschiedenen konvertierroutinen */

do ih=1 to befehlanzahl by 1
   select
     when befehl.ih=1 then do
       zudel=D2C(13) 
       call un
     end /* do */
     when befehl.ih=2 then do
        zudel=D2C(10)
        call un
     end /* do */
     when befehl.ih=3 then do
        suchen=copies(" ", zahl.ih)            /* suchenstring erstellen aus entsprechender anzahl leerzeichen */
        ersetzen=D2C(9)
        szahl=zahl.ih
        call sptab
     end /* do */
     when befehl.ih=4 then do
        suchen=copies(" ", zahl.ih)            /* suchenstring erstellen aus entsprechender anzahl leerzeichen */
        ersetzen=D2C(32)
        szahl=zahl.ih
        call sptab
     end /* do */
     when befehl.ih=5 then do
        suchen=D2C(13)           /* leerzeichen um cr entfernen */    
        szahl=zahl.ih
        call unsk
        suchen=D2C(10)           /* leerzeichen um lf entfernen */
        szahl=zahl.ih
        call unsk
     end /* do */
  end  /* select */
end /* do */


say charout(datein, text)   /* text in neue datei 'datein' schreiben */

exit                                 /* programmende */



un:
/* wenn das cr=return oder lf=linefeed entfernt werden soll... */

  position=1                                                                    /* auf textbegin setzen */
  do forever
    position=pos(zudel, text, position+1)                              /* jeweils nchstes cr suchen */
    if (position=0 | position>length(text)-1) then leave              /* wenn es keines gibt... raus */
    zdavor=substr(text, position-1, 1)                                      /* zeichen vor dem cr bestimmen */
    do while (zdavor=" " & position>2)                                   /* so lange dieses ein leerzeichen ist... */
       position=position-1                                                   /* ...cr wandert dadurch eines runter */
       text=delstr(text, position, 1)                                     /* ...leerzeichen lschen */
       zdavor=substr(text, position-1, 1)                              /* ... neues zeichen vor cr */
    end /* do */
    /* say position zdavor */
    if pos(zdavor, zeichen)=0 then text=overlay(" ", text, position)     /* ist zdavor nicht in der zeichenauswahl enthalten wir cr gegen leerzeichen ausgetauscht */
  end /* do */
return


sptab:
      /* ersetzen von leerzeichen durch tabulatoren und lschen von leerzeichen */
 
  position=1                                                              /* text anfang beginnen */
  do forever    
  position=pos(suchen, text, position+1)                      /* jeweils nchsten leerstring suchen */
    if (position=0 | position>length(text)-1) then leave    /* gibt es keinen mehr ... raus -> */
    text=delstr(text, position, szahl)                           /* die anzahl leerzeichen lschen */
    text=insert(ersetzen, text, position-1)                       /* dort tabulator einfgen */
    leerzahl=0                                  /* leerzeichenzhler fr weitere hinter dem tab auf 0 */
    anfangspos=position+1                  /* hinter dem tab anfangen zu suchen */
    do forever                                         
       if position+1<=length(text) then do                 /* wenn noch text vorhanden ist ... */
         if substr(text, position+1, 1)=" " then do         /* ... und dort ein leerzeichen steht ... */
           leerzahl=leerzahl+1                                   /* ... zhler erhhen */
           position=position+1                                    /* ... nchstes zeichen */
         end /* if */
       end /* if */
       else leave                                                     /* wenn kein text mehr vorhanden ist -> raus */
       if \(substr(text, position+1, 1)=" ")  then leave   /* wenn kein leerzeichen mehr -> raus */
     end /* do */
     if leerzahl>0 then do                                         /* gab es also noch leerzeichen ... */
       text=delstr(text, anfangspos, leerzahl)              /* ... werden die gelscht */
       position=position-leerzahl                                /* .... und die arbeitsposition entsprechend nach unten korrigiert */
     end /* if */
  end /* do forever */
return

unsk:                       /* leerzeichen um zeilenumbruch herum entfernen */ 
  position=1                                                                    /* auf textbegin setzen */
  do forever
    position=pos(suchen, text, position+1)                              /* jeweils nchstes cr/lf suchen */
    if (position=0 | position>length(text)-1) then leave              /* wenn es keines gibt... raus */
    eposition=position
    zdavor=substr(text, position-1, 1)                                      /* zeichen vor dem cr/lf bestimmen */
    do while (zdavor=" " & position>2)                                   /* so lange dieses ein leerzeichen ist... */
       position=position-1                                                   /* ... einen schritt nach unten */
       zdavor=substr(text, position-1, 1)                              /* ... neues zeichen davor */
    end /* do */
    zdahinter=substr(text, eposition+1, 1)                                      /* zeichen hinter dem cr/lf bestimmen */
    do while (zdahinter=" " & eposition<length(text))                                   /* so lange dieses ein leerzeichen ist... */
       eposition=eposition+1                                                   /* ... einen schritt nach oben */
       zdahinter=substr(text, eposition+1, 1)                              /* ... neues zeichen dahinter */
    end /* do */
    text=delstr(text, position, eposition-position+1)                     /* ...leerzeichen lschen */
    text=insert(suchen, text, position-1)                                     /* cr/lf wieder einfgen */
  end /* do */
return


return


stop:
say "Return drcken -> ENDE"
pull ok
exit
return

hilfe:
say" REXX-Skript uncr002.cmd ----- Ilja Kaufmann, 07.04.1997"
say"lscht selektiv berflssige Zeilenumbrche und Leerzeichen aus Texten"
say"und setzt Leerzeichengruppen in Tabulatoren um."
say"Komandozeilenaufruf: uncr002 'Textfilename' Parameterliste"
say"normal per drag'n'drop auszufhren"
say"Parameter (am besten in dieser Reihenfolge):"
say"CR   - Returns (chr13) werden aus dem Text gelscht"
say"LF   - Linefeeds (chr10) werden aus dem Text gelscht"
say"KILL - CR und/oder LF werden auch gelscht, wenn davor ein Satzzeichen steht"
say"TAB3 - ab 3 Leerzeichen werden diese durch Tab ersetzt (Zahl variabel)"
say"SP2  - ab 2 Leerzeichen werden diese zu einem reduziert (Zahl variabel)"
say"SK   - Restliche Leerzeichen vor und nach Zeilenumbrchen werden entfernt"
call stop  
return
